//====================================================================
// œK̂߂̃RXg֐vZvOBEBhEtB
//
//
// 璷RxA[̃[`O  
// e֐߂̊pxp[^ƂāAA[[^[QbgWɈvp[^
// TĂB
// Ae֐߂̓Nm}90xȓŌq񂪂̂ŁA
// Ȃׂ֐߂̉pxt߂̊pxɂ̂D܂ƂłB
// A[̐[^[QbgWɋ߂Ae֐߂̉px
// ΍̂Q捇vقǃRXg֐Ȃ܂B
// ----------------------------------------------------------
// {vO
// http://sysplan.nams.kyushu-u.ac.jp/gen/edu/Algorithms/DownHillSimplexAlgorithm/DownHillSimplexMethod.html
// ̃y[WɎ銊~VvbNX@ɂp[^TvO
// ƂčĂ܂B
// T̗lqoIɊώ@ł܂B
// ֐߂̌͋N̈Ŏwł܂B
// F̉~Ŏ^[QbgW̓}EXňړ邱Ƃł܂B
//
// 2014.10.28 ̂܂ɂȂȂiJavao[VAbvWindowsAbvf[gHĵŁA
//            PLANT_F_CanvasNXrun()\bhɂĎsE\悤ύXi܂łCostFuncRoboWinNXrun()\bhɂăCxgoĂPXebvĂj
//
// ӌE₢킹͈ȉURLɃ[AhX܂̂ŁA
// 炩炨肢܂F
// http://sysplan.nams.kyushu-u.ac.jp/gen/index.html 
//
// Copyright 2006 Hajime Kimura, Kyushu Univ.
// Bw@w@Hw@ CmVXeHw ؑ 
//====================================================================

import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;
import java.util.*;

import java.applet.Applet;
import java.applet.AudioClip;
import java.util.Vector;
import java.util.Hashtable;
import java.util.Enumeration;
import java.net.URL;
import java.net.MalformedURLException;

// ================================================================================
// CostFuncRoboWinNX
// ================================================================================
public class CostFuncRoboWin extends Frame implements ActionListener {
	PLANT_F_Canvas plantCanvas;
	File FlagFile0  ; //  = new File("./", "flag.txt" );
	File EndFile0   ; //  = new File("./", "end.txt" );

	// --------------------------------------------------
	// RXgN^
	// --------------------------------------------------
	CostFuncRoboWin(int numOfHinge ){
		super( "MultiLinkArm" );   // Window Title
		setFont( new Font( "Courier", Font.PLAIN, 12 ) );
		setSize( 512, 512 );
		// Menu, MenuBar
		Menu menu1 = new Menu( "TimeStep" );
		MenuItem t50ms = new MenuItem( "50ms" );
		MenuItem t1sec  = new MenuItem( "1sec" );
		MenuItem quit   = new MenuItem( "quit" );
		menu1.add( t50ms );
		menu1.add( t1sec );
		Menu menu2 = new Menu( "System" );
		menu2.add( quit );
		MenuBar mbar = new MenuBar();
		mbar.add( menu1 );
		mbar.add( menu2 );
		setMenuBar( mbar );
		t50ms.addActionListener( this );
		t1sec.addActionListener( this );
		quit.addActionListener( this );

		//--------------------Plant display initialize
		plantCanvas = new PLANT_F_Canvas( this, numOfHinge );
		add( "Center", plantCanvas );

		System.out.print("Writing config.txt..." );
		try {
			//-------- config.txt t@Co
			PrintWriter pout = new  PrintWriter( new FileOutputStream( "config.txt" ));
			pout.println( plantCanvas.GetConfig() );
			pout.flush() ;
			pout.close() ;
			System.out.println("done." );
		}catch (IOException e){
			System.out.println("IOException about writing config.txt." );
		}
		FlagFile0    = new File("./", "flag.txt" );
		EndFile0     = new File("./", "end.txt" );
		if( EndFile0.exists() ){
			try{
				EndFile0.delete() ;
			} catch ( SecurityException e ){}
		}
		plantCanvas.start();
	}

	// --------------------------------------------------
	// C֐
	// --------------------------------------------------
	public static void main( String args[] ) {
		if( args.length < 1 ) {
			System.out.println();
			System.out.println( "Please input as below" );
			System.out.println( "  \"CostFuncRoboWin + <Number of joints>\"" );
			System.out.println( "  The number of joints must be larger than 2." );
			return ;
		}
		int numOfJoints = Integer.parseInt( args[0] );
		CostFuncRoboWin mla = new CostFuncRoboWin( numOfJoints );
		mla.setVisible( true );   // show();
		mla.run();
	}

	// --------------------------------------------------
	// Xbh̏
	// --------------------------------------------------
	public void run(){
		while (true){

		}
	}

	// GUI EVENT ---------------------------------------------------------------
	public void actionPerformed( ActionEvent e ) {
		if( e.getActionCommand().equals( "50ms" ) ) {
			plantCanvas.setSleepTime( 50 );
		}else if( e.getActionCommand().equals( "1sec" ) ) {
			plantCanvas.setSleepTime( 1000 );
		}else if( e.getActionCommand().equals( "quit" ) ) {
			try {
				StringBuffer strBuf = new StringBuffer() ;
				strBuf.append( "end.txt" ) ;
				PrintWriter pout = new  PrintWriter( new FileOutputStream( strBuf.toString() ));
				pout.println( " " );
				pout.flush() ;
				pout.close() ;
			}catch( IOException er ) {
				System.err.println( "File I/O Exception" );
			}
			System.exit( 0 );
		}
	}
}

// ======================================================================
// `̂߂̃EChE 
// ======================================================================
class PLANT_F_Canvas extends Canvas implements Runnable, MouseMotionListener {
	Thread runner; 
	int SleepTime;
	CostFuncRoboWin psPtr;
	Font theFont;
	Image offscreenImage;
	Graphics offscreenGraphics;
	int cwidth, cheight;
	double param[];
	double cost ;
	MultiJointArm Environment;   // 
	boolean newEventWasOccured ;

	// --------------------------------------------------
	// RXgN^
	// --------------------------------------------------
	PLANT_F_Canvas( CostFuncRoboWin psPtrIn, int numberOfHinge ) {
		SleepTime = 50;   // l50msecƂ
		psPtr = psPtrIn;
		Environment = new MultiJointArm( numberOfHinge );
		param = new double[Environment.GetNumOfParameters()] ;
		theFont = new Font( "Courier", Font.PLAIN, 12 );   // "TimesRoman",Font.BOLD,16);
		cwidth = 16;
		cheight = 16;
		newEventWasOccured = true ;
		addMouseMotionListener(this);
	}
	//------------------------------------GUI }EXhbOꂽꍇ
	public void mouseDragged( MouseEvent e ) {
		double tmpx = (double)e.getX() ;
		double tmpy = (double) e.getY() ;
		double widthX = (double) this.getSize().width ;
		double widthY = (double) this.getSize().height;
		tmpx = tmpx / widthX ;
		tmpy = 1 - (tmpy / widthY) ;
		Environment.SetGoal( tmpx, tmpy ); // }EXʒuS[ʒuW֔f
		System.out.println( "New Goal = " + tmpx + " " + tmpy );   
		newEventWasOccured = false ;
	}
	public void mouseMoved( MouseEvent e ) { }

	// --------------------------------------------------
	// Xbhs郁\bh "start"
	// --------------------------------------------------
	public void start() {
		if( runner == null ) {
			runner = new Thread( this );
			runner.start();
		}
	}
	// --------------------------------------------------
	// VԂ܂ł̎ԂZbg郁\bh
	// --------------------------------------------------
	public void setSleepTime( int t ) {
		SleepTime = t;
	}
	// --------------------------------------------------
	// Xbh̏
	// --------------------------------------------------

	public void run() {
		boolean endFlag = false;
		moveOneStep();
		repaint();
		while( true ) {
			//-----tOt@C܂ő҂
//			System.out.print("tOt@C܂ő҂..." );
			while( !psPtr.FlagFile0.exists() ){ 
			}
//			System.out.println("OK" );
			//-----p[^t@Cǂݍ
//			System.out.print("p[^t@Cǂݍ..." );
			StringBuffer message = new StringBuffer() ;
			try {
				//---̂͂܂ȂƎv
				BufferedReader din = new BufferedReader( new InputStreamReader( new FileInputStream("param.txt")));
				String line = din.readLine();
				message.append( line ).append(" \n");
				System.out.println( message.toString() );
				din.close();
			} catch( Exception IOException){ 
				System.out.println("Can't open file 'param.txt'." );
			}
			SetParameters( message.toString() ) ;
//			System.out.println("OK" );
			//-----------ԑJڂN܂ő҂
//			System.out.print("ԑJڂN܂ő҂..." );

//			while( !plantCanvas.getNewEventOccuredFlag() ){
				// wait
//			}
//			System.out.println("OK" );
			moveOneStep();
			repaint();
			try{ Thread.sleep( SleepTime ); }
			catch ( InterruptedException e ){ }
			//----------]l result.txt ֏o
//			System.out.print("]l result.txt ֏o..." );
			try{
				//-----t@CJăXg[o͐ƂiPrintWriterNXj
				PrintWriter LogStrm = new  PrintWriter( new FileOutputStream( "result.txt" ));
				double cost =  GetCost() ;
				LogStrm.println( "cost " + cost);     
				System.out.println( "cost " + cost);    
				LogStrm.flush() ;               // Ăł͂߂ďos@KrŌɂ
				LogStrm.close() ;
			} catch( Exception IOException){ 
				System.out.println("Can't open file <result.txt>." );
			}
//			System.out.println("OK" );
			//----tOt@C
//			System.out.print("tOt@C..." );
			try{
				psPtr.FlagFile0.delete() ;
			} catch ( SecurityException e ){
				System.out.println("sI" );
			}
//			System.out.println("OK" );
		}
	}
	// --------------------------------------------------
	// ʕ`p\bh
	// --------------------------------------------------
	public void paint( Graphics g ) {
		// offscreen--------------------------------------------------------------
		if( ( cwidth != this.getSize().width ) || ( cheight != this.getSize().height ) ) {
			cwidth = this.getSize().width;
			cheight = this.getSize().height;
			offscreenImage = createImage( this.getSize().width, this.getSize().height );
			offscreenGraphics = offscreenImage.getGraphics();
			offscreenGraphics.setFont( theFont );
			Environment.InitDisp( this.getSize().width, this.getSize().height );
		}
		//------------ŎۂɃ{bg
		// moveOneStep();
		Environment.DispEnvironment( offscreenGraphics );
		//--------------offscreen to DC
		g.drawImage( offscreenImage, 0, 0, this );
	}
	public void update( Graphics g ) {
		paint( g );
	}
	// --------------------------------------------------
	// XbhŎs郁\bh "moveOneStep"
	// --------------------------------------------------
	public synchronized void moveOneStep() {
		cost = Environment.Evaluate( param );
		newEventWasOccured = true;  // Cxg
	}
	// --------------------------------------------------
	// ̏Ԃ\bh "GetInformation"
	// --------------------------------------------------
	public synchronized String GetConfig() {
		return( Environment.GetConfig() );
	}
	// --------------------------------------------------
	// RXǧvZʂ̒lԂ\bh 
	// --------------------------------------------------
	public synchronized double GetCost() {
		return( cost );
	}
	// --------------------------------------------------
	// ֑p[^i[郁\bh 
	// --------------------------------------------------
	public synchronized void SetParameters( String s ) {
		StringTokenizer st = new StringTokenizer( s );
		String word;
		for( int i = 0; i < Environment.GetNumOfParameters(); i++ ) {
			if( st.hasMoreTokens() ) {
				word = st.nextToken();
				try {
					param[i] = Double.valueOf( word ).doubleValue();
				}catch( NumberFormatException e ) {
					System.out.println( "Error: Number of Parameter is lacking." );
				}
			}
		}
		newEventWasOccured = false ;
	}
	//-------------------------------------
	public boolean getNewEventOccuredFlag(){return( newEventWasOccured );}
	//------------------
}
